'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = ensureBuffer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*!
 * Copyright (c) 2015-2019 Cisco Systems, Inc. See LICENSE file.
 */

/**
* Ensures the provider Buffer is, indeed, a Buffer; sometimes, they seem to be
* byte-arrays instead of proper Buffer objects.
* @param {mixed} buffer
* @returns {Promise<Buffer>}
*/
function ensureBuffer(buffer) {
  /* istanbul ignore if */
  if (!Buffer.isBuffer(buffer)) {
    return _promise2.default.reject(new Error('`buffer` must be a buffer'));
  }

  return _promise2.default.resolve(buffer);
}
//# sourceMappingURL=ensure-buffer.js.map
