'use strict';
const models = require('../models');
class TeamEventBase {
    constructor(teamEventType, team, tenantInfo) {
        this.eventType = teamEventType;
        this.team = team;
        this.tenant = tenantInfo;
    }
    mapper() {
        return {
            required: false,
            serializedName: 'TeamEventBase',
            type: {
                name: 'Composite',
                className: 'eventType',
                modelProperties: {
                    eventType: {
                        required: false,
                        serializedName: 'eventType',
                        type: {
                            name: 'Number'
                        }
                    },
                    teamInfo: {
                        required: false,
                        serializedName: 'team',
                        type: {
                            name: 'Composite',
                            className: 'TeamInfo'
                        }
                    },
                    tenantInfo: {
                        required: false,
                        serializedName: 'tenant',
                        type: {
                            name: 'Composite',
                            className: 'TenantInfo'
                        }
                    }
                }
            }
        };
    }
}
const TeamEventType = {
    MembersAdded: 0,
    MembersRemoved: 1,
    ChannelCreated: 2,
    ChannelDeleted: 3,
    ChannelRenamed: 4,
    TeamRenamed: 5
};
module.exports.TeamEventBase = TeamEventBase;
module.exports.TeamEventType = TeamEventType;
